#!groovy
@Library('libs@main')

import com.infineon.pipelines.*
import com.infineon.stages.*
import com.infineon.helpers.*
import com.infineon.steps.*

def JENKINS_HELPER = new JenkinsHelper(this)

// def MLINFRADEV_REPO = new GitSCM(this, 'https://gitlab.intra.infineon.com/adsm/ml-infra-dev-repo')

try
{
    def jenkins_name = "inf_ml_dev"
    def path

    node('ml_dev_node-1')
    {
        env.WORKSPACE = sh (
            script: 'pwd',
            returnStdout: true
        ).trim()
    }

    echo env.WORKSPACE
    
    def p = new Pipeline(this, 100)

    /*

    def repo_ml_dev_node  = new RepoUpdateStepMLDevNode(this, 'ml-infra-dev-repo', 'https://gitlab.intra.infineon.com/adsm/', 'main')

    p << new Stage('RepoUpdateStep', this)
        .addStep(repo_ml_dev_node)

    */

    def repo_jenkins  = new RepoUpdateStep(this, 'jenkins') 

    p << new Stage('RepoUpdateStep', this)
        .addStep(repo_jenkins)

    def verify_dataset_creation = new RunScriptStep(this, '1', '1 Dataset Creation')

    p << new Stage('RunScriptStep', this)
        .addStep(verify_dataset_creation)

    def verify_phoneme_generation = new RunScriptStep(this, '2', '2 Phoneme Generation')

    p << new Stage('RunScriptStep', this)
        .addStep(verify_phoneme_generation)

    def archive_artifacts = new ArchiveArtifactsStep(this)

    p << new Stage('ArchiveArtifactsStep', this)
        .addStep(archive_artifacts)

    p.execute()
    
}
catch (e)
{
    echo 'The Job failed'
    throw e
}
finally
{
    // TODO def REV_ID = JENKINS_HELPER.getRevId(MLINFRADEV_REPO)
}